ALTER PROCEDURE A_S_RES_APPLAY_CORRECTION_1(
    IDUSER INTEGER,
    RES_RABMAT INTEGER,
    RES_TRUDTYPE INTEGER,
    RES_MASKA VARCHAR(42),
    RES_CORRECT VARCHAR(50),
    RES_CORRECT_REPLACE INTEGER,
    RES_ID INTEGER)
RETURNS (
    ID_SM_REC_CH_TRUD INTEGER,
    ID_SL_REC_CH_NR_AND_KOLL INTEGER)
AS
DECLARE VARIABLE ID_SL_REC INTEGER;
DECLARE VARIABLE APPLAY_CORRECT VARCHAR(50);
DECLARE VARIABLE CALC_RASHOD_IFLAG INTEGER;
DECLARE VARIABLE APPLAY_RASHOD DOUBLE PRECISION;
DECLARE VARIABLE CUR_RES_CORRECT VARCHAR(50);
DECLARE VARIABLE CUR_RES_TAB VARCHAR(42);
DECLARE VARIABLE CUR_RES_RABMAT INTEGER;
DECLARE VARIABLE CUR_RES_RASHOD_BASE DOUBLE PRECISION;
DECLARE VARIABLE CUR_RES_RASHOD DOUBLE PRECISION;
DECLARE VARIABLE CUR_RES_TYPE_TRUD INTEGER;
DECLARE VARIABLE CUR_RES_ID_SOURCE INTEGER;
DECLARE VARIABLE SM_KOLL DOUBLE PRECISION;
DECLARE VARIABLE SM_ID INTEGER;
DECLARE VARIABLE BOOL_DOIT INTEGER;
begin

--exception le_bad_zone;

 if ( res_correct is null )
 then res_correct = '';

 if (
     ( res_maska is null ) or
     ( res_maska = '' )
    )
 then res_maska = '%';

 select first 1 r.rabmat, r.type_trud, r.rashod, r.rashod_base, r.correct, r.tab, r.id_source
 from a_s_res r
 where r.id = :res_id
 into :cur_res_rabmat, :cur_res_type_trud, :cur_res_rashod, :cur_res_rashod_base,
      :cur_res_correct, :cur_res_tab, :cur_res_id_source;


 -- Kir
 if ( cur_res_type_trud is null ) then
  cur_res_type_trud = 0;

 if ( cur_res_correct is null ) then cur_res_correct = '';

 id_sl_rec = null;

 bool_doit=1;
--DEN-->18/4/5 cq [571]          
 if ((res_rabmat=-1)and(res_trudtype=-1)) then
 begin

--   res_rabmat = :cur_res_rabmat;
--   res_trudtype = :cur_res_type_trud;
   bool_doit=1;
 end
 else
--<--DEN
 if (res_rabmat<>1) then
 begin
   if
   (
     ( cur_res_rabmat = res_rabmat ) and
     ( cur_res_tab like res_maska )
   )
   then
     bool_doit=1;
   else
     bool_doit=0;
 end
 else
 begin
   /* Kir */
   if( res_trudtype = 0 ) then
      res_trudtype = cur_res_type_trud; /*rvs: */
   /* --- */
   if
   (
     ( cur_res_rabmat = res_rabmat ) and
     ( cur_res_tab like res_maska ) and
     ( cur_res_type_trud = res_trudtype )
   )
   then
     bool_doit=1;
   else
     bool_doit=0;
 end


 if (bool_doit=1) then
 begin

  if ( res_correct_replace <> 1 )
  then applay_correct = substring(cur_res_correct /*|| ')' */|| res_correct from 1 for 50);
  else applay_correct = res_correct;

  select first 1 iflag, ditognormrash
  from k_calculatenormrash( :applay_correct, :cur_res_rashod_base, :iduser )
  into :calc_rashod_iflag, :applay_rashod;



  update a_s_res r1
  set r1.correct = :applay_correct
  where r1.id = :res_id;

--exception le_bad_zone 'applay_correct ' ||  calc_rashod_iflag || ' - ' || applay_rashod || '  ' || applay_rashod;
--exception le_bad_zone 'applay_correct' || '  ' || applay_correct || '  ' || calc_rashod_iflag || '  ' || cur_res_rashod || '  ' || applay_rashod;

  if (
--DEN-->18/4/5 cq [571]
      ((res_rabmat=-1)and(res_trudtype=-1))or
--<--DEN
      (( calc_rashod_iflag = 1 ) and
      ( cur_res_rashod <> applay_rashod ))
     )

  then
  begin

--exception le_bad_zone applay_rashod;

   update a_s_res r1
   set r1.rashod = :applay_rashod,
       r1.status_edit = 1
   where r1.id = :res_id;

   select first 1 s.id
   from a_smeta s
   where s.id_s_res = :res_id
   into :id_sl_rec;

   if (
       ( cur_res_rabmat = 1 ) and
       ( cur_res_type_trud in (1,2) )
      )
   then
   begin

    id_sm_rec_ch_trud = cur_res_id_source;
    id_sl_rec_ch_nr_and_koll   = null;

    suspend;

   end

   if ( not ( id_sl_rec is null ) )
   then
   begin

    sm_koll = 0;

    sm_id = null;

    select s.slaveparent
    from a_smeta s
    where s.id = :id_sl_rec
    into :sm_id;

    select s.koll
    from a_smeta s
    where s.id = :sm_id
    into :sm_koll;

    update a_smeta s
    set s.koll = :sm_koll * :applay_rashod,
        s.normarash = :applay_rashod
    where s.id = :id_sl_rec;

    id_sm_rec_ch_trud = null;
    id_sl_rec_ch_nr_and_koll = id_sl_rec;

    suspend;

   end

  end

 end

end
^












ALTER PROCEDURE L_IMP_IS_SRF_TR_EXISTS(
    NAME VARCHAR(250),
    NORM_GUID VARCHAR(100),
    PRECED INTEGER,
    PRECIT INTEGER,
    COUNT_FRM INTEGER,
    SUM_NUMBER_FRM INTEGER,
    SUM_NUMBER_VR INTEGER,
    COUNT_VR INTEGER,
    SUM_VR INTEGER,
    COUNT_F3_VR INTEGER,
    F_SEA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SEB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SEC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SED BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SEE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SEF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SEG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SEH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SEI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SEJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SRA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SRB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SRC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SRD BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SRE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SRF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SRG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SRH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SRI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SRJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SRK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SRL BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_SRM BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    F_PA DOUBLE PRECISION,
    F_PB DOUBLE PRECISION,
    F_PC DOUBLE PRECISION,
    F_PD DOUBLE PRECISION,
    F_PE DOUBLE PRECISION,
    L_SEA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SEB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SEC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SED BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SEE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SEF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SEG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SEH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SEI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SEJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SRA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SRB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SRC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SRD BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SRE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SRF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SRG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SRH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SRI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SRJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SRK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SRL BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_SRM BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    L_PA DOUBLE PRECISION,
    L_PB DOUBLE PRECISION,
    L_PC DOUBLE PRECISION,
    L_PD DOUBLE PRECISION,
    L_PE DOUBLE PRECISION,
    ID_USER INTEGER)
RETURNS (
    RESULT INTEGER)
AS
declare variable id integer;
declare variable tmp_name varchar(250);
begin
   RESULT = 0;
   id = null;

   if ( ( not NORM_GUID is null ) and ( NORM_GUID <> '' ) ) then
   begin
      select first 1 id from A_SRF_TR T WHERE T.NORM_GUID = :NORM_GUID into id;
      if ( id is null ) then
         exit;
      execute procedure L_IMP_COMPARE_SRF_TR1 ( :id, :name, :preced, :precit,
             :count_frm, :sum_number_frm, :sum_number_vr, :count_vr, :sum_vr, :count_f3_vr,
             :F_PA, :F_PB, :F_PC, :F_PD, :F_PE,
             :L_PA, :L_PB, :L_PC, :L_PD, :L_PE,
             :id_user )
         returning_values ( :result );
/*      execute procedure L_IMP_COMPARE_SRF_TR ( :id, :name, :preced, :precit,
             :count_frm, :sum_number_frm, :sum_number_vr, :count_vr, :sum_vr, :count_f3_vr,
             :F_SEA, :F_SEB, :F_SEC, :F_SED, :F_SEE, :F_SEF, :F_SEG, :F_SEH, :F_SEI, :F_SEJ,
             :F_SRA, :F_SRB, :F_SRC, :F_SRD, :F_SRE, :F_SRF, :F_SRG, :F_SRH, :F_SRI, :F_SRJ, :F_SRK, :F_SRL, :F_SRM,
             :F_PA, :F_PB, :F_PC, :F_PD, :F_PE,
             :L_SEA, :L_SEB, :L_SEC, :L_SED, :L_SEE, :L_SEF, :L_SEG, :L_SEH, :L_SEI, :L_SEJ,
             :L_SRA, :L_SRB, :L_SRC, :L_SRD, :L_SRE, :L_SRF, :L_SRG, :L_SRH, :L_SRI, :L_SRJ, :L_SRK, :L_SRL, :L_SRM,
             :L_PA, :L_PB, :L_PC, :L_PD, :L_PE,
             :id_user )
         returning_values ( :result );*/
      if ( result <> 0 ) then
         exit;
   end
--   else
   begin
      name = lckuppervarchar ( :name );
      for select id, name from A_SRF_TR into id , tmp_name do
         if ( lckuppervarchar ( :tmp_name ) = name ) then
         begin
            execute procedure L_IMP_COMPARE_SRF_TR1 ( :id, :name, :preced, :precit,
             :count_frm, :sum_number_frm, :sum_number_vr, :count_vr, :sum_vr, :count_f3_vr,
             :F_PA, :F_PB, :F_PC, :F_PD, :F_PE,
             :L_PA, :L_PB, :L_PC, :L_PD, :L_PE,
                   :id_user )
                returning_values ( :result );
/*            execute procedure L_IMP_COMPARE_SRF_TR ( :id, :name, :preced, :precit,
             :count_frm, :sum_number_frm, :sum_number_vr, :count_vr, :sum_vr, :count_f3_vr,
             :F_SEA, :F_SEB, :F_SEC, :F_SED, :F_SEE, :F_SEF, :F_SEG, :F_SEH, :F_SEI, :F_SEJ,
             :F_SRA, :F_SRB, :F_SRC, :F_SRD, :F_SRE, :F_SRF, :F_SRG, :F_SRH, :F_SRI, :F_SRJ, :F_SRK, :F_SRL, :F_SRM,
             :F_PA, :F_PB, :F_PC, :F_PD, :F_PE,
             :L_SEA, :L_SEB, :L_SEC, :L_SED, :L_SEE, :L_SEF, :L_SEG, :L_SEH, :L_SEI, :L_SEJ,
             :L_SRA, :L_SRB, :L_SRC, :L_SRD, :L_SRE, :L_SRF, :L_SRG, :L_SRH, :L_SRI, :L_SRJ, :L_SRK, :L_SRL, :L_SRM,
             :L_PA, :L_PB, :L_PC, :L_PD, :L_PE,
                   :id_user )
                returning_values ( :result );*/
            if ( result <> 0 ) then
               exit;
         end

   end
end
^

